/**
 * CompanyService.java
 *
 * Created on 28 Agu 2010 17:50:46
 */
package org.blueoxygen.cimande.company.service;

import java.util.List;

import org.blueoxygen.cimande.company.Company;

/**
 * @author Dian Aditya
 *
 */
public interface CompanyService {

	void save(Company company);

	void delete(Company company);

	Company getCompanyById(String id);

	List<Company> getAllCompanies(String orderby);

	List<Company> findCompanies(String name, String address, String state,
			String zipNumber, String telephone, String faximile,
			String website, String email, String orderby, int maxResults,
			int firstResult);

	List<Company> findCompaniesByField(String field, String value);

	int getRowCountByCriteria(String name, String address, String state,
			String zipNumber, String telephone, String faximile,
			String website, String email);
}
