/*******************************************************************************
 * Copyright (c) 2011 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Cimande Team - initial API and implementation
 *******************************************************************************/
package org.blueoxygen.cimande.privilege;

import org.blueoxygen.cimande.commons.DefaultPersistence;
import org.blueoxygen.cimande.modulefunction.ModuleFunction;

/**
 * @author Dian Aditya
 * 
 */
public abstract class Privilege extends DefaultPersistence {
	public abstract ModuleFunction getModuleFunction();

	public abstract int getPrivilage_flag();

	public abstract String getUrl_xml();
}
