package org.blueoxygen.cimande.role.actions.servicewfrole;

import java.util.List;
import org.blueoxygen.cimande.role.Role;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public interface ServiceWfRole {
	void save(Role role);

	void delete(Role role);

	Role getRoleById(String Id);

	List<Role> getAllRoles(String orderby);

	List<Role> findRoles(String name, String description, int activeFlag,
			String orderby, int maxResults, int firstResult);

	List<Role> findRoless(String name, String description);

	List<Role> findRolesByField(String field, String value);

	int getRowCountByCriteria(String name, String description);
}
