/**
 * ModuleFunctionService.java
 *
 * Created on 29 Agu 2010 00:37:43
 */
package org.blueoxygen.cimande.modulefunction.service;

import java.util.List;

import org.blueoxygen.cimande.modulefunction.ModuleFunction;

/**
 * @author Dian Aditya
 * 
 */
public interface ModuleFunctionService {
	void save(ModuleFunction moduleFunction);

	void delete(ModuleFunction moduleFunction);

	ModuleFunction getModuleFunctionById(String id);

	List<ModuleFunction> getModuleFunctionsByCriteria(String name,
			String description, String tableRef, String moduleFunctionId,
			String moduleDescriptorsId, String orderby, int maxResults,
			int firstResult);

	long getRowCountByCriteria(String name, String description);
}
