/*******************************************************************************
 * Copyright (c) 2005 BlueOxygen Technology.
 *******************************************************************************/
package org.blueoxygen.cimande.roleprivilage.actions;

import org.blueoxygen.cimande.role.RolePrivilage;

/**
 * @author Miftachur Rohman
 *
 */
public class EditRolePrivilage extends RolePrivilageForm {

	public String execute() {
		RolePrivilage rolePrivilage = service
				.getRolePrivilageById(getRole_id());

		rolePrivilage.setRole(getRole());
		rolePrivilage.setId(role_id);
		rolePrivilage.setModuleFunction(getModuleFunction());
		rolePrivilage.setId(module_function_id);
		if (hasErrors()) {
			return INPUT;
		} else {
			service.save(rolePrivilage);
			return SUCCESS;
		}
	}

}