package org.blueoxygen.cimande.roleprivilage.service;

import java.util.List;
import org.blueoxygen.cimande.modulefunction.ModuleFunction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.RolePrivilage;

/*******************************
 * @author Praditya Eldorado aldo.donal@gmail.com
 *******************************/

public interface RolePrivilageService {
	void save(RolePrivilage rolePrivilage);

	void delete(RolePrivilage rolePrivilage);

	RolePrivilage getRolePrivilageById(String id);

	List<RolePrivilage> getAllRolePrivilages();

	List<RolePrivilage> findRolePrivilages(String Url_xml,
			String Privilage_flag, String Role, String ModuleFunction,
			int maxResults, int firstResult);

	List<RolePrivilage> findRolePrivilagesByField(String field, String value);

	int getRowCountByCriteria(Role role2, ModuleFunction moduleFunction,
			String Role, int i);

	List<RolePrivilage> getRolePrivilages(Role role);

	List<RolePrivilage> getList(String roleId, int activeFlag);

	List<RolePrivilage> getLists(String parentId, String roleId, int activeFlag);

	List findRolePrivilages(Role role, ModuleFunction moduleFunction,
			String url_xml, int privilage_flag, String orderBy,
			int maxRowPerPage, int i);
}
