package org.blueoxygen.cimande.section.actions;

import java.util.List;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.descriptors.Descriptor;

public class ListSectionDescriptor extends CimandeAction {

	private List descriptors;
	protected Descriptor descriptor;

	public String execute() {
		descriptors = manager.findAllSorted(Descriptor.class, "name");

		model.put("descriptorlist", descriptors);

		return SUCCESS;
	}

	public Descriptor getDescriptor() {
		return descriptor;
	}

	public void setDescriptor(Descriptor descriptor) {
		this.descriptor = descriptor;
	}

	public List getDescriptors() {
		return descriptors;
	}

	public void setDescriptors(List descriptors) {
		this.descriptors = descriptors;
	}

}
