package org.blueoxygen.cimande.security.usermanager.actions;

import org.blueoxygen.util.StringUtils;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class ChangePassord extends UserForm {
	String pass = "";
	StringUtils su = new StringUtils();
	String newPassword = "";
	String newPassword1 = "";

	public String execute() {
		newPassword = getNewPassword();
		newPassword1 = getNewPassword1();

		if (!newPassword.equals(newPassword1)) {
			addActionError("Password tidak cocok");
		}
		if (newPassword == null || "".equalsIgnoreCase(newPassword)) {
			addActionError("Password tidak boleh kosong");
		}
		if (hasErrors()) {
			return INPUT;
		} else {
			user = service.getUserbyId(getUser().getId());
			user.setPassword(su.encodeBase64(newPassword));
			service.save(user);

			return SUCCESS;
		}
	}
}
