package org.blueoxygen.cimande.site.service;

import java.util.List;

import org.blueoxygen.cimande.site.Site;

/*******************************
 * @author Praditya Eldorado aldo.donal@gmail.com
 *******************************/

public interface SiteService {
	void save(Site site);

	void delete(Site site);

	Site getSiteById(String id);

	List<Site> getAllSites(String orderby);

	List<Site> findSites(String name, String description, String title,
			String url_branding, String site_url, String admin_email,
			int notify_flag, String notify_email, String notify_from,
			String notify_message, int activeFlag, String workspace_type,
			String orderby, int maxResults, int firstResult);

	List<Site> findSitesByField(String field, String value);

	int getRowCountByCriteria(String name, String description, String title,
			String url_branding, String site_url, String admin_email,
			String notify_email, String notify_from, String notify_message,
			String workspace_type);

}
